{{define "rsvp.html"}}
<section id="rsvp" class="flex flex-col justify-center items-center">
	<h1>RSVP</h1>
	<p class="mb-8 font-bold italic">
		Please respond by 31 May 2023; earlier responses will help us with planning, so an earlier response is much
		appreciated
	</p>
	<form id="form-rsvp">
		{{/* ------ Guest Form ------ */}}
		<fieldset>
			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<label for="name" class="col-span-2">My full name is</label>
				<input type="text" id="name" name="name" class="w-100 col-span-3 md:col-span-2">
			</div>
			<p>
				We might need to share some information with you all closer to the wedding. For this purpose, please
				provide us with your contact details:
			</p>
			<div class="field grid grid-cols-2 md:grid-cols-3 gap-5 items-center justify-center">
				<label for="email-address" class="col-span-1">Email:</label>
				<input type="text" id="email-address" name="email-address">
			</div>
			<div class="field grid grid-cols-2 md:grid-cols-3 gap-5 items-center justify-center">
				<label for="phone-number" class="col-span-1">Phone:</label>
				<input type="text" id="phone-number" name="phone-number">
				<p class="col-span-2 md:col-span-3">
					Please ensure that you include correct country code with your phone number
				</p>
			</div>
			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<p class="col-span-4 md:col-span-3 lg:col-span-2">I will attend the wedding ceremony & reception on 1st
					September</p>
				<div class="flex flex-row items-center justify-center">
					<label for="attending-ceremony-true" class="flex items-center mr-5">Yes</label>
					<input type="radio" id="attending-ceremony-true" name="attending-ceremony" value="true"
						class="flex items-center w-14">
				</div>
				<div class="flex flex-row items-center justify-center">
					<label for="attending-ceremony-false" class="flex items-center mr-5">No</label>
					<input type="radio" id="attending-ceremony-false" name="attending-ceremony" value="false"
						class="flex items-center w-14">
				</div>
			</div>
			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<p class="col-span-4 md:col-span-3 lg:col-span-2">I will attend the after party on 2nd September</p>
				<div class="flex flex-row items-center justify-center">
					<label for="attending-party-true" class="flex items-center mr-5">Yes</label>
					<input type="radio" id="attending-party-true" name="attending-party" value="true"
						class="flex items-center w-14">
				</div>
				<div class="flex flex-row items-center justify-center">
					<label for="attending-party-false" class="flex items-center mr-5">No</label>
					<input type="radio" id="attending-party-false" name="attending-party" value="false"
						class="flex items-center w-14">
				</div>
			</div>
			<div class="field flex flex-col justify-evenly">
				<p>
					Please let us know if you are vegetarian or vegan.
				</p>
				<div class="grid grid-cols-5 gap-y-5 mt-5 items-center justify-center">
					<label for="dr-none" class="col-start-1 row-start-1 flex items-center">None</label>
					<input type="radio" id="dr-none" name="dietary-requirements" value="none"
						class="col-start-2 row-start-1">

					<label for="dr-vegetarian" class="col-start-1 row-start-2 flex items-center">Vegetarian</label>
					<input type="radio" id="dr-vegetarian" name="dietary-requirements" value="vegetarian"
						class="col-start-2 row-start-2">

					<label for="dr-vegan" class="col-start-1 row-start-3 flex items-center">Vegan</label>
					<input type="radio" id="dr-vegan" name="dietary-requirements" value="vegan"
						class="col-start-2 row-start-3">

					<label for="dr-other" class="col-start-1 row-start-4 flex items-center">Other</label>
					<input type="radio" id="dr-other" name="dietary-requirements" value="other"
						class="col-start-2 row-start-4">
					{{/* TODO: make other text field hidden until other is selected */}}
					<input type="text" id="dr-other-text" name="dietary-requirements-text" placeholder="Please specify"
						class="col-start-3 col-span-3 row-start-4">
				</div>
			</div>

			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<p class="col-span-4 md:col-span-3 lg:col-span-2">
					Do you have any food allergies or intollerances?
				</p>
				<div class="flex flex-row items-center justify-center">
					<label for="has-allergies-true" class="flex items-center mr-5">Yes</label>
					<input type="radio" id="has-allergies-true" name="has-allergies" value="true"
						class="flex items-center w-14">
				</div>
				<div class="flex flex-row items-center justify-center">
					<label for="has-allergies-false" class="flex items-center mr-5">No</label>
					<input type="radio" id="has-allergies-false" name="has-allergies" value="false"
						class="flex items-center w-14">
				</div>
			</div>
			<div class="grid grid-cols-5 gap-y-5 mt-5 items-center justify-center">
				<label for="allergies" class="col-span-2">
					If you have any food allergies or intollerances, please let us know the details and severity here so
					we can inform our catering staff
				</label>
				<input type="text" id="allergies" name="allergies" class="col-span-3" placeholder="Please specifiy">
				<p class="col-span-5">
					If you have severe allergies please contact Mark or Natasza directly.
				</p>
			</div>

			<div class="field grid-cols-5 gap-5 mt-10 {{if .}}grid{{else}}hidden{{end}}">
				<p class="col-span-2">I will bring a significant other</p>
				<div class="flex flex-row items-center justify-center">
					<label for="so-attending-true" class="flex items-center mr-5">Yes</label>
					<input type="radio" id="so-attending-true" name="so-attending" value="true"
						class="flex items-center w-14">
				</div>
				<div class="flex flex-row items-center justify-center">
					<label for="so-attending-false" class="flex items-center mr-5">No</label>
					<input type="radio" id="so-attending-false" name="so-attending" value="false"
						class="flex items-center w-14" checked>
				</div>
			</div>
		</fieldset>
		{{/* ------ SO Form ------ */}}
		<fieldset id="so-form" class="hidden transform transition ease-in-out delay-150">
			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<label for="so-name" class="col-span-2">My significant other's full name is</label>
				<input type="text" id="so-name" name="so-name" class="w-100 col-span-3 md:col-span-2">
			</div>
			<p>
				We might need to share some information with you all closer to the wedding. For this purpose, please
				provide us with <span class="so-name">your significant other</span>'s contact details:
			</p>
			<div class="field grid grid-cols-2 md:grid-cols-3 gap-5 items-center justify-center">
				<label for="so-email-address" class="col-span-1">Email:</label>
				<input type="text" id="so-email-address" name="so-email-address">
			</div>
			<div class="field grid grid-cols-2 md:grid-cols-3 gap-5 items-center justify-center">
				<label for="so-phone-number" class="col-span-1">Phone:</label>
				<input type="text" id="so-phone-number" name="so-phone-number">
				<p class="col-span-2 md:col-span-3">
					Please ensure that you include correct country code with their phone number
				</p>
			</div>
			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<p class="col-span-4 md:col-span-3 lg:col-span-2"><span class="so-name">My significant other</span> will
					attend the wedding ceremony & reception on 1st September</p>
				<div class="flex flex-row items-center justify-center">
					<label for="so-attending-ceremony-true" class="flex items-center mr-5">Yes</label>
					<input type="radio" id="so-attending-ceremony-true" name="so-attending-ceremony" value="true"
						class="flex items-center w-14">
				</div>
				<div class="flex flex-row items-center justify-center">
					<label for="so-attending-ceremony-false" class="flex items-center mr-5">No</label>
					<input type="radio" id="so-attending-ceremony-false" name="so-attending-ceremony" value="false"
						class="flex items-center w-14">
				</div>
			</div>
			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<p class="col-span-4 md:col-span-3 lg:col-span-2"><span class="so-name">My significant other</span> will
					attend the after party on 2nd September</p>
				<div class="flex flex-row items-center justify-center">
					<label for="so-attending-party-true" class="flex items-center mr-5">Yes</label>
					<input type="radio" id="so-attending-party-true" name="so-attending-party" value="true"
						class="flex items-center w-14">
				</div>
				<div class="flex flex-row items-center justify-center">
					<label for="so-attending-party-false" class="flex items-center mr-5">No</label>
					<input type="radio" id="so-attending-party-false" name="so-attending-party" value="false"
						class="flex items-center w-14">
				</div>
			</div>
			<div class="field flex flex-col justify-evenly">
				<p>
					Please let us know if <span class="so-name">your significant other</span> is vegetarian or vegan.
				</p>
				<div class="grid grid-cols-5 gap-y-5 mt-5 items-center justify-center">
					<label for="so-dr-none" class="col-start-1 row-start-1 flex items-center">None</label>
					<input type="radio" id="so-dr-none" name="so-dietary-requirements" value="none"
						class="col-start-2 row-start-1">

					<label for="so-dr-vegetarian" class="col-start-1 row-start-2 flex items-center">Vegetarian</label>
					<input type="radio" id="so-dr-vegetarian" name="so-dietary-requirements" value="vegetarian"
						class="col-start-2 row-start-2">

					<label for="so-dr-vegan" class="col-start-1 row-start-3 flex items-center">Vegan</label>
					<input type="radio" id="so-dr-vegan" name="so-dietary-requirements" value="vegan"
						class="col-start-2 row-start-3">

					<label for="so-dr-other" class="col-start-1 row-start-4 flex items-center">Other</label>
					<input type="radio" id="so-dr-other" name="so-dietary-requirements" value="other"
						class="col-start-2 row-start-4">
					{{/* TODO: make other text field hidden until other is selected */}}
					<input type="text" id="so-dr-other-text" name="so-dietary-requirements-text"
						placeholder="Please specify" class="col-start-3 col-span-3 row-start-4">
				</div>
			</div>

			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<p class="col-span-4 md:col-span-3 lg:col-span-2">
					Does <span class="so-name">your significant other</span> have any food allergies or intollerances?
				</p>
				<div class="flex flex-row items-center justify-center">
					<label for="so-has-allergies-true" class="flex items-center mr-5">Yes</label>
					<input type="radio" id="so-has-allergies-true" name="so-has-allergies" value="true"
						class="flex items-center w-14">
				</div>
				<div class="flex flex-row items-center justify-center">
					<label for="so-has-allergies-false" class="flex items-center mr-5">No</label>
					<input type="radio" id="so-has-allergies-false" name="so-has-allergies" value="false"
						class="flex items-center w-14">
				</div>
			</div>
			<div class="grid grid-cols-5 gap-y-5 mt-5 items-center justify-center">
				<label for="so-allergies" class="col-span-2">
					If <span class="so-name">your significant other</span> has any food allergies or intollerances,
					please let us know the details and severity here so we can inform our catering staff
				</label>
				<input type="text" id="so-allergies" name="so-allergies" class="col-span-3"
					placeholder="Please specify">
				<p class="col-span-5">
					If you have severe allergies please also contact Mark or Natasza directly.
				</p>
			</div>

		</fieldset>
		{{/* ------ Composite form ------- */}}
		<fieldset>
			<div class="field grid grid-cols-2 md:grid-cols-3 gap-5 items-center justify-center">
				<label for="song-request" class="col-span-1">I will dance during the reception if the following song is
					played:</label>
				<input type="text" id="song-request" name="song-request" class="col-span-2 md:col-span-1"
					placeholder="optional">
			</div>
			<div class="field grid grid-cols-5 gap-5 items-center justify-center">
				<p class="col-span-2">In order to estimate the number of parking spaces that might be required at the
					Highcliffe Castle, please let us know if you're planning on driving to and parking at the venue:</p>
				<div class="flex flex-row items-center justify-center">
					<label for="parking-space-required-true" class="flex items-center mr-5">Yes</label>
					<input type="radio" id="parking-space-required-true" name="parking-space-required" value="true"
						class="flex items-center w-14">
				</div>
				<div class="flex flex-row items-center justify-center">
					<label for="parking-space-required-false" class="flex items-center mr-5">No</label>
					<input type="radio" id="parking-space-required-false" name="parking-space-required" value="false"
						class="flex items-center w-14">
				</div>
			</div>
		</fieldset>
		<div id="validation-error-message"
			class="px-20 py-10 rounded-md bg-red-300 flex-row items-center justify-center text-center my-10 hidden">
			<span>Please ensure that all questions on the RSVP form have been answered.</span>
		</div>
		<div class="flex flex-row justify-center items-center">
			<button id="send-rsvp" type="button" class="px-10 py-3 bg-blue-600 text-white">
				Send
			</button>
		</div>
	</form>
	<div id="rsvp-recieved" class="hidden rounded-md bg-green-200 px-20 py-10 mt-10">
		Thank you for sending us your RSVP.
	</div>

	<script>
		const soAttendingInputs = document.querySelectorAll("input[name='so-attending']");
		const soForm = document.querySelector("#so-form");
		const soNameInput = document.querySelector("#so-name");
		const soNameSpans = document.querySelectorAll(".so-name");
		const sendButton = document.querySelector("#send-rsvp");
		const validationMessage = document.querySelector("#validation-error-message");


		function getRadioValue(name) {
			radioButton = document.querySelector('input[name="' + name + '"]:checked')
			if (radioButton) {
				return radioButton.value;
			}
			{ {/* console.error("cannot find element input[name='"+name+"']:checked"); */ } }
			return null;
		}

		function getTextBoxValue(selector) {
			return document.querySelector(selector).value;
		}

		function isSoAttending() {
			return getRadioValue("so-attending") === "true" ? true : false;
		}

		function toggleSoForm() {
			if (isSoAttending()) {
				soForm.classList.remove("hidden");
				return;
			}
			soForm.classList.add("hidden");
		}

		function getGuestData(isSo = false) {
			selectorPrefix = isSo ? "so-" : "";
			return {
				name: getTextBoxValue("#" + selectorPrefix + "name"),
				attending_ceremony: getRadioValue(selectorPrefix + "attending-ceremony"),
				attending_party: getRadioValue(selectorPrefix + "attending-party"),
				dietary_requirements: getRadioValue(selectorPrefix + "dietary-requirements"),
				dietary_requirements_text: getTextBoxValue("#" + selectorPrefix + "dr-other-text"),
				has_allergies: getRadioValue(selectorPrefix + "has-allergies"),
				allergies: getTextBoxValue("#" + selectorPrefix + "allergies"),
				email_address: getTextBoxValue("#" + selectorPrefix + "email-address"),
				phone_number: getTextBoxValue("#" + selectorPrefix + "phone-number"),
			};
		}

		function getCompositeData() {
			return {
				song_request: getTextBoxValue("#song-request"),
				parking_space_required: getRadioValue("parking-space-required"),
			};
		}

		function validateGuestData(data) {
			if (typeof (data.name) !== "string") {
				return false;
			}
			if (data.name == "") {
				return false;
			}

			if (typeof (data.email_address) !== "string") {
				return false;
			}
			if (data.email_address == "") {
				return false;
			}

			if (typeof (data.phone_number) !== "string") {
				return false;
			}
			if (data.phone_number == "") {
				return false;
			}


			if (typeof (data.attending_ceremony) !== "string") {
				return false;
			}
			if (data.attending_ceremony == "") {
				return false;
			}

			if (typeof (data.dietary_requirements) !== "string") {
				return false;
			}
			if (data.dietary_requirements == "") {
				return false;
			}

			if (data.dietary_requirements == "other") {
				if (typeof (data.dietary_requirements) !== "string" || data.dietary_requirements_text == "") {
					return false;
				}
			}

			if (typeof data.has_allergies !== "string" || data.has_allergies == "") {
				return false;
			}
			if (data.has_allergies == "true") {
				if (typeof (data.allergies) !== "string" || data.allergies == "") {
					return false;
				}
			}

			return true;
		}

		function validateCompositeData(data) {
			if (typeof (data.parking_space_required) !== "string") {
				return false;
			}
			if (data.parking_space_required == "") {
				return false;
			}

			return true;
		}

		function getData() {
			const guestData = getGuestData(false);
			if (!validateGuestData(guestData)) {
				throw new ValidationException("Please make sure that the whole form has been completed.");
			}
			let soData = {
				name: "",
				attending_ceremony: "false",
				attending_party: "false",
				dietary_requirements: "",
				dietary_requirements_text: "",
			};
			if (isSoAttending()) {
				soData = getGuestData(true)
				if (!validateGuestData(soData)) {
					throw new ValidationException("Please make sure that the whole form has been completed.");
				}
			}

			const compositeData = getCompositeData();
			if (!validateCompositeData(compositeData)) {
				throw new ValidationException("Please make sure that the whole form has been completed.");
			}
			return {
				guest: guestData,
				so: soData,
				composite: compositeData,
			};
		}

		function sendData(data) {
			fetch("/natasza-and-mark/rsvp", {
				method: "POST",
				body: JSON.stringify(data),
			})
				.then(console.log(data))
				.then(() => {
					document.querySelector("#form-rsvp").classList.add("hidden");
					document.querySelector("#rsvp-recieved").classList.remove("hidden");
					document.querySelector("#rsvp").scrollIntoView();
				})
				.catch((err) => console.error(err));

		}

		sendButton.addEventListener("click", function (e) {
			validationMessage.classList.remove("flex");
			validationMessage.classList.add("hidden");

			let data = null;
			try {
				data = getData();
			} catch (ex) {
				if (ex.name == "ValidationException") {
					validationMessage.classList.remove("hidden");
					validationMessage.classList.add("flex");
					return;
				}
				throw ex;
			}

			sendButton.disabled = true;
			sendButton.innerHtml = "Sending..."
			console.log(sendButton);

			if (data === null) {
				throw new Error("This state should not be possible and should have been caught by an earlier error");
			}

			sendData(data);
		});

		soAttendingInputs.forEach((el) => el.addEventListener("change", function (e) {
			toggleSoForm();
		}));

		soNameInput.addEventListener("change", function (e) {
			soNameSpans.forEach(function (s) {
				s.textContent = soNameInput.value;
			});
		});

		document.addEventListener('DOMContentLoaded', function (event) {
			toggleSoForm();
		});

		class ValidationException extends Error {
			constructor(message) {
				super(message);
				this.name = this.constructor.name;
			}
		}
	</script>
</section>
{{end}}